/* gopher.h
 *
 * Part of the Internet Gopher program, copyright (C) 1991
 * University of Minnesota Microcomputer Workstation and Networks Center
 *
 */

/*** All our mongo include files ***/

#include <stdio.h>
#include "mstcp.h"
#include <process.h>

/*** Set global configuration options early ***/
#include "conf.h"

#ifdef IS_MESS_DOS
#ifdef PCNFS
#ifdef PTK40
#include <tklib.h>
#endif
#endif
#endif

#ifndef IS_BSD
#ifndef IS_NEXT
#include <stdlib.h>
#endif
#endif

#include <sys/types.h>
#include <signal.h>
#include <sys/stat.h>

/*
#include <sys/socket.h>
#include <netinet/in.h>
*/

#ifdef IS_MESS_DOS
#include <fcntl.h>
/* #include <io.h> */
#define index(s,c)  strchr(s,c)
#define rindex(s,c) strrchr(s,c)
/* #include <4bsddefs.h> */
#else
#include <file.h>
#endif /* MESS_DOS */

/*
#ifdef LWP
#define socketclose(x)	soclose(x)
#else
#ifndef PTK40
#ifndef IS_A_HPUX
#include <arpa/inet.h>
#endif
#endif
#endif

#include <netdb.h>

*/
#ifdef IS_A_DEC
#include <cursesX.h>
#else
#include <curses.h>
#endif

#ifdef __convex__
#define cbreak crmode
#endif

#ifndef __convex__
#include <string.h>
#endif

#ifndef IS_A_HPUX
#include <string.h>
#endif

#ifdef IS_MESS_DOS
#define strncasecmp(s1,s2,i) strnicmp(s1,s2,i)
#endif /* MESS_DOS */

#include <ctype.h>
#include <errno.h>
#include <time.h>

#ifndef socketclose
#define socketclose(x) close(x)
#endif

#define HALFLINE 40
#define WHOLELINE 80

#define MAXSTR 200           /* Arbitrary maximum string length */

#include "STRstrin.h"
#include "error.h"
#include "gopherst.h"
#include "stack.h"

/** Get the configuration variables **/

#include "globals.h"

/** Load in the header files for the various structures **/

#include "forms.h"
